<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.7"/>
<title>TI  Graph Library   (TIGL): /home/mohamed/code/tigl/examples/tiglExamplesPageRank.hpp Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/search.js"></script>
<script type="text/javascript">
  $(document).ready(function() { searchBox.OnSelectItem(0); });
</script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td style="padding-left: 0.5em;">
   <div id="projectname">TI  Graph Library   (TIGL)
   &#160;<span id="projectnumber">ver1.0</span>
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.7 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "search",false,'Search');
</script>
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li>
        <div id="MSearchBox" class="MSearchBoxInactive">
        <span class="left">
          <img id="MSearchSelect" src="search/mag_sel.png"
               onmouseover="return searchBox.OnSearchSelectShow()"
               onmouseout="return searchBox.OnSearchSelectHide()"
               alt=""/>
          <input type="text" id="MSearchField" value="Search" accesskey="S"
               onfocus="searchBox.OnSearchFieldFocus(true)" 
               onblur="searchBox.OnSearchFieldFocus(false)" 
               onkeyup="searchBox.OnSearchFieldChange(event)"/>
          </span><span class="right">
            <a id="MSearchClose" href="javascript:searchBox.CloseResultsWindow()"><img id="MSearchCloseImg" border="0" src="search/close.png" alt=""/></a>
          </span>
        </div>
      </li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
<a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(0)"><span class="SelectionMark">&#160;</span>All</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(1)"><span class="SelectionMark">&#160;</span>Classes</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(2)"><span class="SelectionMark">&#160;</span>Files</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(3)"><span class="SelectionMark">&#160;</span>Functions</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(4)"><span class="SelectionMark">&#160;</span>Variables</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(5)"><span class="SelectionMark">&#160;</span>Macros</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(6)"><span class="SelectionMark">&#160;</span>Groups</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(7)"><span class="SelectionMark">&#160;</span>Pages</a></div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="dir_5cb698dd68e4a64db08e4a31a28ab366.html">examples</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="headertitle">
<div class="title">tiglExamplesPageRank.hpp</div>  </div>
</div><!--header-->
<div class="contents">
<a href="tiglExamplesPageRank_8hpp.html">Go to the documentation of this file.</a><div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;</div>
<div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160;<span class="preprocessor">#ifndef TIGLEXAMPLESPAGERANK_HPP_</span></div>
<div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160;<span class="preprocessor">#define TIGLEXAMPLESPAGERANK_HPP_</span></div>
<div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160;</div>
<div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160;<span class="preprocessor">#include &quot;<a class="code" href="tiglVertex_8hpp.html">tiglAPIVertex.hpp</a>&quot;</span></div>
<div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;<span class="preprocessor">#include &quot;<a class="code" href="tiglMessage_8hpp.html">tiglAPIMessage.hpp</a>&quot;</span></div>
<div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160;<span class="preprocessor">#include &quot;<a class="code" href="tiglCombiner_8hpp.html">tiglAPICombiner.hpp</a>&quot;</span></div>
<div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160;</div>
<div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160;<span class="preprocessor">#include &lt;vector&gt;</span></div>
<div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;</div>
<div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;<span class="keyword">using namespace </span>std;</div>
<div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160;<span class="comment">//--------------------------------------------------------------------------------------------------------------------------------------</span></div>
<div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160;<span class="comment">//--------------------------------------------------------------------------------------------------------------------------------------</span></div>
<div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160;<span class="comment">//--------------------------------------------------------------------------------------------------------------------------------------</span></div>
<div class="line"><a name="l00023"></a><span class="lineno">   23</span>&#160;</div>
<div class="line"><a name="l00043"></a><span class="lineno">   43</span>&#160;<span class="keyword">template</span> &lt;<span class="keyword">typename</span> DataType = <span class="keywordtype">char</span>&gt;</div>
<div class="line"><a name="l00044"></a><span class="lineno"><a class="line" href="classVertexPageRank.html">   44</a></span>&#160;<span class="keyword">class </span><a class="code" href="classVertexPageRank.html">PageRankVertex</a>:</div>
<div class="line"><a name="l00045"></a><span class="lineno">   45</span>&#160;        <span class="keyword">public</span> <a class="code" href="classVertex.html">Vertex</a>&lt;DataType, double, TIGLContainersEdgeBase&lt;uint_fast32_t&gt;, uint_fast32_t, uint_fast32_t, DblMessage&gt;</div>
<div class="line"><a name="l00046"></a><span class="lineno">   46</span>&#160;{</div>
<div class="line"><a name="l00047"></a><span class="lineno">   47</span>&#160;<span class="keyword">public</span>:</div>
<div class="line"><a name="l00048"></a><span class="lineno">   48</span>&#160;    <span class="keyword">typedef</span> <span class="keyword">typename</span> <a class="code" href="classVertex.html">Vertex&lt;DataType, double, TIGLContainersEdgeBase&lt;uint_fast32_t&gt;</a>, uint_fast32_t, uint_fast32_t, <a class="code" href="classMessage.html">DblMessage</a>&gt;::MESSAGE_BUF_TYPE  MESSAGE_BUF_TYPE;</div>
<div class="line"><a name="l00049"></a><span class="lineno">   49</span>&#160;    <span class="keyword">typedef</span> <span class="keyword">typename</span> <a class="code" href="classVertex.html">Vertex&lt;DataType, double, TIGLContainersEdgeBase&lt;uint_fast32_t&gt;</a>, uint_fast32_t, uint_fast32_t, <a class="code" href="classMessage.html">DblMessage</a>&gt;::OUT_EDGE_ITERATOR OUT_EDGE_ITERATOR;</div>
<div class="line"><a name="l00050"></a><span class="lineno">   50</span>&#160;</div>
<div class="line"><a name="l00051"></a><span class="lineno">   51</span>&#160;<span class="keyword">protected</span>:</div>
<div class="line"><a name="l00053"></a><span class="lineno"><a class="line" href="classVertexPageRank.html#a982b395425a77266ee20f9b1ec85735b">   53</a></span>&#160;    <span class="keyword">static</span> uint_fast32_t <a class="code" href="classVertexPageRank.html#a982b395425a77266ee20f9b1ec85735b">numVertices</a>;</div>
<div class="line"><a name="l00054"></a><span class="lineno">   54</span>&#160;</div>
<div class="line"><a name="l00055"></a><span class="lineno">   55</span>&#160;<span class="keyword">public</span>:</div>
<div class="line"><a name="l00057"></a><span class="lineno"><a class="line" href="classVertexPageRank.html#ad059296361152b10c464f3dd94f852d8">   57</a></span>&#160;    <a class="code" href="classVertexPageRank.html#ad059296361152b10c464f3dd94f852d8">PageRankVertex</a>(uint_fast32_t key):<a class="code" href="classVertex.html">Vertex</a>&lt;char, double, <a class="code" href="classEdgeBase.html">TIGLContainersEdgeBase</a>&lt;uint_fast32_t&gt;, uint_fast32_t, uint_fast32_t, <a class="code" href="classMessage.html">DblMessage</a>&gt;(key, true, false){}</div>
<div class="line"><a name="l00058"></a><span class="lineno">   58</span>&#160;    ~<a class="code" href="classVertexPageRank.html">PageRankVertex</a>(){}</div>
<div class="line"><a name="l00059"></a><span class="lineno">   59</span>&#160;</div>
<div class="line"><a name="l00060"></a><span class="lineno">   60</span>&#160;<span class="keyword">public</span>:</div>
<div class="line"><a name="l00061"></a><span class="lineno">   61</span>&#160;    <span class="comment">//===================================================================================================================================</span></div>
<div class="line"><a name="l00067"></a><span class="lineno">   67</span>&#160;<span class="comment"></span></div>
<div class="line"><a name="l00068"></a><span class="lineno">   68</span>&#160;    <span class="keyword">template</span> &lt;<span class="keyword">typename</span> ALLOCATOR_TYPE&gt;</div>
<div class="line"><a name="l00069"></a><span class="lineno"><a class="line" href="classVertexPageRank.html#ac8e29e2a338d708f74f1e0ab7f0e4955">   69</a></span>&#160;    uint_fast32_t <a class="code" href="classVertexPageRank.html#ac8e29e2a338d708f74f1e0ab7f0e4955">compute</a>(MESSAGE_BUF_TYPE *pIn,</div>
<div class="line"><a name="l00070"></a><span class="lineno">   70</span>&#160;                    vector &lt;DblMessage, ALLOCATOR_TYPE&gt; *pOut,</div>
<div class="line"><a name="l00071"></a><span class="lineno">   71</span>&#160;                    uint_fast32_t numMessages)</div>
<div class="line"><a name="l00072"></a><span class="lineno">   72</span>&#160;    {</div>
<div class="line"><a name="l00073"></a><span class="lineno">   73</span>&#160;        <span class="keywordtype">double</span> newRank = 0.0;</div>
<div class="line"><a name="l00074"></a><span class="lineno">   74</span>&#160;        <span class="keywordflow">if</span>(numMessages &gt; 1)<span class="comment">//if(pIn-&gt;size() &gt; 1)</span></div>
<div class="line"><a name="l00075"></a><span class="lineno">   75</span>&#160;            cout&lt;&lt;<span class="stringliteral">&quot;!!! Warning PregelPageR compute: numMessages(&quot;</span> &lt;&lt; this-&gt;getId() &lt;&lt; <span class="stringliteral">&quot;) = &quot;</span> &lt;&lt; numMessages &lt;&lt; endl;<span class="comment">//cout&lt;&lt;&quot;!!! Warning : numMessages(&quot; &lt;&lt; this-&gt;getId() &lt;&lt; &quot;) = &quot; &lt;&lt; pIn-&gt;size() &lt;&lt; endl;</span></div>
<div class="line"><a name="l00076"></a><span class="lineno">   76</span>&#160;        <span class="keywordflow">if</span>(numMessages &gt; pIn-&gt;size())<span class="comment">//if(pIn-&gt;size() &gt; 1)</span></div>
<div class="line"><a name="l00077"></a><span class="lineno">   77</span>&#160;            cout&lt;&lt;<span class="stringliteral">&quot;!!! Warning PregelPageR compute: numMessages is bigger than buffer size&quot;</span>&lt;&lt; endl;</div>
<div class="line"><a name="l00078"></a><span class="lineno">   78</span>&#160;</div>
<div class="line"><a name="l00079"></a><span class="lineno">   79</span>&#160;        <span class="comment">// computing the new rank from the input messages</span></div>
<div class="line"><a name="l00080"></a><span class="lineno">   80</span>&#160;        vector&lt;DblMessage&gt;::iterator itm = pIn-&gt;begin();</div>
<div class="line"><a name="l00081"></a><span class="lineno">   81</span>&#160;        <span class="keywordflow">for</span>(uint_fast32_t loopCount = 0; loopCount &lt; numMessages; loopCount++)<span class="comment">//itm != pIn-&gt;end(); ++itm)</span></div>
<div class="line"><a name="l00082"></a><span class="lineno">   82</span>&#160;        {</div>
<div class="line"><a name="l00083"></a><span class="lineno">   83</span>&#160;            newRank += itm-&gt;getContent();</div>
<div class="line"><a name="l00084"></a><span class="lineno">   84</span>&#160;            ++itm;</div>
<div class="line"><a name="l00085"></a><span class="lineno">   85</span>&#160;        }</div>
<div class="line"><a name="l00086"></a><span class="lineno">   86</span>&#160;</div>
<div class="line"><a name="l00087"></a><span class="lineno">   87</span>&#160;</div>
<div class="line"><a name="l00088"></a><span class="lineno">   88</span>&#160;        newRank = newRank*0.85 + 0.15/(double)numVertices;</div>
<div class="line"><a name="l00089"></a><span class="lineno">   89</span>&#160;        this-&gt;algData = newRank;</div>
<div class="line"><a name="l00090"></a><span class="lineno">   90</span>&#160;</div>
<div class="line"><a name="l00091"></a><span class="lineno">   91</span>&#160;        <span class="comment">// now generating the output messages</span></div>
<div class="line"><a name="l00092"></a><span class="lineno">   92</span>&#160;        uint_fast32_t numOutMessages = 0;</div>
<div class="line"><a name="l00093"></a><span class="lineno">   93</span>&#160;        <span class="keywordtype">double</span> messageVal = (this-&gt;algData)/(<span class="keywordtype">double</span>)(this-&gt;getNumOutEdges());</div>
<div class="line"><a name="l00094"></a><span class="lineno">   94</span>&#160;        <span class="keywordflow">for</span>(OUT_EDGE_ITERATOR ite = this-&gt;getBeginOutEdgeIterator(); ite != this-&gt;getEndOutEdgeIterator(); ++ite)</div>
<div class="line"><a name="l00095"></a><span class="lineno">   95</span>&#160;        {</div>
<div class="line"><a name="l00096"></a><span class="lineno">   96</span>&#160;            uint_fast32_t dst = ite-&gt;getNbr();</div>
<div class="line"><a name="l00097"></a><span class="lineno">   97</span>&#160;            <span class="keywordflow">if</span>(dst == this-&gt;<span class="keywordtype">id</span>)</div>
<div class="line"><a name="l00098"></a><span class="lineno">   98</span>&#160;                <span class="keywordflow">continue</span>; <span class="comment">// ignoring self reference</span></div>
<div class="line"><a name="l00099"></a><span class="lineno">   99</span>&#160;            <a class="code" href="classMessage.html">DblMessage</a> newMessage(this-&gt;<span class="keywordtype">id</span>, dst, messageVal);</div>
<div class="line"><a name="l00100"></a><span class="lineno">  100</span>&#160;            pOut-&gt;push_back(newMessage);</div>
<div class="line"><a name="l00101"></a><span class="lineno">  101</span>&#160;            numOutMessages++;</div>
<div class="line"><a name="l00102"></a><span class="lineno">  102</span>&#160;        }</div>
<div class="line"><a name="l00103"></a><span class="lineno">  103</span>&#160;</div>
<div class="line"><a name="l00104"></a><span class="lineno">  104</span>&#160;</div>
<div class="line"><a name="l00105"></a><span class="lineno">  105</span>&#160;        <span class="comment">//this-&gt;flagActive = true;</span></div>
<div class="line"><a name="l00106"></a><span class="lineno">  106</span>&#160;        <span class="keywordflow">return</span> numOutMessages;</div>
<div class="line"><a name="l00107"></a><span class="lineno">  107</span>&#160;    }</div>
<div class="line"><a name="l00108"></a><span class="lineno">  108</span>&#160;</div>
<div class="line"><a name="l00109"></a><span class="lineno">  109</span>&#160;    <span class="comment">//===================================================================================================================================</span></div>
<div class="line"><a name="l00114"></a><span class="lineno">  114</span>&#160;<span class="comment"></span></div>
<div class="line"><a name="l00115"></a><span class="lineno">  115</span>&#160;    <span class="keyword">template</span> &lt;<span class="keyword">typename</span> ALLOCATOR_TYPE&gt;</div>
<div class="line"><a name="l00116"></a><span class="lineno"><a class="line" href="classVertexPageRank.html#ab0311d771c6c45604d015ee3dbc3f78a">  116</a></span>&#160;    uint_fast32_t <a class="code" href="classVertexPageRank.html#ab0311d771c6c45604d015ee3dbc3f78a">init</a>(uint_fast32_t *pNumVertices, vector &lt;DblMessage, ALLOCATOR_TYPE&gt; *pOut)</div>
<div class="line"><a name="l00117"></a><span class="lineno">  117</span>&#160;    {</div>
<div class="line"><a name="l00118"></a><span class="lineno">  118</span>&#160;        numVertices = *pNumVertices;</div>
<div class="line"><a name="l00119"></a><span class="lineno">  119</span>&#160;        this-&gt;algData = 1.0/numVertices;</div>
<div class="line"><a name="l00120"></a><span class="lineno">  120</span>&#160;        <span class="keywordtype">double</span> messageVal = (this-&gt;algData)/(<span class="keywordtype">double</span>)(this-&gt;getNumOutEdges());</div>
<div class="line"><a name="l00121"></a><span class="lineno">  121</span>&#160;</div>
<div class="line"><a name="l00122"></a><span class="lineno">  122</span>&#160;        uint_fast32_t numOutMessages = 0;</div>
<div class="line"><a name="l00123"></a><span class="lineno">  123</span>&#160;        <span class="keywordflow">for</span>(OUT_EDGE_ITERATOR ite = this-&gt;getBeginOutEdgeIterator(); ite != this-&gt;getEndOutEdgeIterator(); ++ite)</div>
<div class="line"><a name="l00124"></a><span class="lineno">  124</span>&#160;        {</div>
<div class="line"><a name="l00125"></a><span class="lineno">  125</span>&#160;            uint_fast32_t dst = ite-&gt;getNbr();</div>
<div class="line"><a name="l00126"></a><span class="lineno">  126</span>&#160;            <span class="keywordflow">if</span>(dst == this-&gt;<span class="keywordtype">id</span>)</div>
<div class="line"><a name="l00127"></a><span class="lineno">  127</span>&#160;                <span class="keywordflow">continue</span>; <span class="comment">// ignoring self reference</span></div>
<div class="line"><a name="l00128"></a><span class="lineno">  128</span>&#160;            <a class="code" href="classMessage.html">DblMessage</a> newMessage(this-&gt;<span class="keywordtype">id</span>, dst, messageVal);</div>
<div class="line"><a name="l00129"></a><span class="lineno">  129</span>&#160;            pOut-&gt;push_back(newMessage);</div>
<div class="line"><a name="l00130"></a><span class="lineno">  130</span>&#160;            numOutMessages++;</div>
<div class="line"><a name="l00131"></a><span class="lineno">  131</span>&#160;        }</div>
<div class="line"><a name="l00132"></a><span class="lineno">  132</span>&#160;        this-&gt;flagActive = <span class="keyword">true</span>;</div>
<div class="line"><a name="l00133"></a><span class="lineno">  133</span>&#160;        <span class="keywordflow">return</span> numOutMessages;</div>
<div class="line"><a name="l00134"></a><span class="lineno">  134</span>&#160;    }</div>
<div class="line"><a name="l00135"></a><span class="lineno">  135</span>&#160;</div>
<div class="line"><a name="l00136"></a><span class="lineno">  136</span>&#160;};</div>
<div class="line"><a name="l00137"></a><span class="lineno">  137</span>&#160;</div>
<div class="line"><a name="l00138"></a><span class="lineno">  138</span>&#160;<span class="keyword">template</span> &lt;<span class="keyword">typename</span> DataType&gt;</div>
<div class="line"><a name="l00139"></a><span class="lineno">  139</span>&#160;uint_fast32_t <a class="code" href="classVertexPageRank.html">PageRankVertex&lt;DataType&gt;::numVertices</a>;</div>
<div class="line"><a name="l00140"></a><span class="lineno">  140</span>&#160;</div>
<div class="line"><a name="l00141"></a><span class="lineno">  141</span>&#160;<span class="comment">//--------------------------------------------------------------------------------------------------------------------------------------</span></div>
<div class="line"><a name="l00142"></a><span class="lineno">  142</span>&#160;<span class="comment">//--------------------------------------------------------------------------------------------------------------------------------------</span></div>
<div class="line"><a name="l00143"></a><span class="lineno">  143</span>&#160;<span class="comment">//--------------------------------------------------------------------------------------------------------------------------------------</span></div>
<div class="line"><a name="l00151"></a><span class="lineno"><a class="line" href="classtiglCombinerPageRank.html">  151</a></span>&#160;<span class="comment"></span><span class="keyword">class </span><a class="code" href="classtiglCombinerPageRank.html">tiglCombinerPageRank</a>:</div>
<div class="line"><a name="l00152"></a><span class="lineno">  152</span>&#160;        <span class="keyword">public</span> <a class="code" href="classtiglCombiner.html">tiglCombiner</a>&lt;DblMessage&gt;</div>
<div class="line"><a name="l00153"></a><span class="lineno">  153</span>&#160;{</div>
<div class="line"><a name="l00154"></a><span class="lineno">  154</span>&#160;<span class="keyword">public</span>:</div>
<div class="line"><a name="l00155"></a><span class="lineno">  155</span>&#160;    <span class="keyword">typedef</span> <span class="keyword">typename</span> vector&lt;DblMessage&gt;::iterator   MESSAGE_ITERATOR;</div>
<div class="line"><a name="l00156"></a><span class="lineno">  156</span>&#160;</div>
<div class="line"><a name="l00157"></a><span class="lineno">  157</span>&#160;<span class="keyword">public</span>:</div>
<div class="line"><a name="l00158"></a><span class="lineno">  158</span>&#160;    <a class="code" href="classtiglCombinerPageRank.html">tiglCombinerPageRank</a>(){}</div>
<div class="line"><a name="l00159"></a><span class="lineno">  159</span>&#160;    ~<a class="code" href="classtiglCombinerPageRank.html">tiglCombinerPageRank</a>(){}</div>
<div class="line"><a name="l00160"></a><span class="lineno">  160</span>&#160;<span class="keyword">public</span>:</div>
<div class="line"><a name="l00162"></a><span class="lineno"><a class="line" href="classtiglCombinerPageRank.html#a7aa6ec254b762243317a39dd8865dd46">  162</a></span>&#160;    <span class="keyword">inline</span> uint_fast32_t <a class="code" href="classtiglCombinerPageRank.html#a7aa6ec254b762243317a39dd8865dd46">combineMessages</a>(MESSAGE_ITERATOR itIn, uint_fast32_t numMessages, MESSAGE_ITERATOR itOut)</div>
<div class="line"><a name="l00163"></a><span class="lineno">  163</span>&#160;    {</div>
<div class="line"><a name="l00164"></a><span class="lineno">  164</span>&#160;         <span class="keywordflow">return</span> this-&gt;sumCombineMessages(itIn, numMessages, itOut);</div>
<div class="line"><a name="l00165"></a><span class="lineno">  165</span>&#160;    }</div>
<div class="line"><a name="l00166"></a><span class="lineno">  166</span>&#160;</div>
<div class="line"><a name="l00168"></a><span class="lineno"><a class="line" href="classtiglCombinerPageRank.html#a3b9fb314bdb02926e40fe61ae69f7ec7">  168</a></span>&#160;    <span class="keyword">inline</span> uint_fast32_t <a class="code" href="classtiglCombinerPageRank.html#a3b9fb314bdb02926e40fe61ae69f7ec7">combineMessages</a>(<a class="code" href="classMessage.html">DblMessage</a> &amp; newMessage, MESSAGE_ITERATOR itOut)</div>
<div class="line"><a name="l00169"></a><span class="lineno">  169</span>&#160;    {</div>
<div class="line"><a name="l00170"></a><span class="lineno">  170</span>&#160;         <span class="keywordflow">return</span> this-&gt;sumCombineMessages(newMessage, itOut);</div>
<div class="line"><a name="l00171"></a><span class="lineno">  171</span>&#160;    }</div>
<div class="line"><a name="l00172"></a><span class="lineno">  172</span>&#160;};</div>
<div class="line"><a name="l00173"></a><span class="lineno">  173</span>&#160;</div>
<div class="line"><a name="l00174"></a><span class="lineno">  174</span>&#160;<span class="preprocessor">#endif </span><span class="comment">/* PREGELPAGER_HPP_ */</span><span class="preprocessor"></span></div>
<div class="ttc" id="classtiglCombiner_html"><div class="ttname"><a href="classtiglCombiner.html">tiglCombiner</a></div><div class="ttdoc">pure combiner class in the Pregel engine It contains the definitions of the combine function and has ...</div><div class="ttdef"><b>Definition:</b> tiglAPICombiner.hpp:31</div></div>
<div class="ttc" id="classtiglCombinerPageRank_html"><div class="ttname"><a href="classtiglCombinerPageRank.html">tiglCombinerPageRank</a></div><div class="ttdoc">Combiner class for the page rank algorithm: it uses sum combining. </div><div class="ttdef"><b>Definition:</b> tiglExamplesPageRank.hpp:151</div></div>
<div class="ttc" id="classMessage_html"><div class="ttname"><a href="classMessage.html">Message</a></div><div class="ttdoc">core data message class definition It handles all the data message fields and processing It is a temp...</div><div class="ttdef"><b>Definition:</b> tiglAPIMessage.hpp:30</div></div>
<div class="ttc" id="classVertexPageRank_html_ac8e29e2a338d708f74f1e0ab7f0e4955"><div class="ttname"><a href="classVertexPageRank.html#ac8e29e2a338d708f74f1e0ab7f0e4955">PageRankVertex::compute</a></div><div class="ttdeci">uint_fast32_t compute(MESSAGE_BUF_TYPE *pIn, vector&lt; DblMessage, ALLOCATOR_TYPE &gt; *pOut, uint_fast32_t numMessages)</div><div class="ttdoc">customized compute function </div><div class="ttdef"><b>Definition:</b> tiglExamplesPageRank.hpp:69</div></div>
<div class="ttc" id="classVertexPageRank_html"><div class="ttname"><a href="classVertexPageRank.html">PageRankVertex</a></div><div class="ttdoc">Customized class for the page rank algorithm by Google as defined in the original Pregel paper...</div><div class="ttdef"><b>Definition:</b> tiglExamplesPageRank.hpp:44</div></div>
<div class="ttc" id="classtiglCombinerPageRank_html_a7aa6ec254b762243317a39dd8865dd46"><div class="ttname"><a href="classtiglCombinerPageRank.html#a7aa6ec254b762243317a39dd8865dd46">tiglCombinerPageRank::combineMessages</a></div><div class="ttdeci">uint_fast32_t combineMessages(MESSAGE_ITERATOR itIn, uint_fast32_t numMessages, MESSAGE_ITERATOR itOut)</div><div class="ttdoc">customized combine function that calls the generic sum combine </div><div class="ttdef"><b>Definition:</b> tiglExamplesPageRank.hpp:162</div></div>
<div class="ttc" id="classVertexPageRank_html_a982b395425a77266ee20f9b1ec85735b"><div class="ttname"><a href="classVertexPageRank.html#a982b395425a77266ee20f9b1ec85735b">PageRankVertex::numVertices</a></div><div class="ttdeci">static uint_fast32_t numVertices</div><div class="ttdoc">numVertices: a static member that holds the total number of vertices </div><div class="ttdef"><b>Definition:</b> tiglExamplesPageRank.hpp:53</div></div>
<div class="ttc" id="classEdgeBase_html"><div class="ttname"><a href="classEdgeBase.html">TIGLContainersEdgeBase</a></div><div class="ttdoc">core edge class </div><div class="ttdef"><b>Definition:</b> tiglContainersEdgeBase.hpp:31</div></div>
<div class="ttc" id="tiglMessage_8hpp_html"><div class="ttname"><a href="tiglMessage_8hpp.html">tiglAPIMessage.hpp</a></div><div class="ttdoc">contains core Massage container class for tigl </div></div>
<div class="ttc" id="tiglCombiner_8hpp_html"><div class="ttname"><a href="tiglCombiner_8hpp.html">tiglAPICombiner.hpp</a></div><div class="ttdoc">contains the definition of the combiner class </div></div>
<div class="ttc" id="classtiglCombinerPageRank_html_a3b9fb314bdb02926e40fe61ae69f7ec7"><div class="ttname"><a href="classtiglCombinerPageRank.html#a3b9fb314bdb02926e40fe61ae69f7ec7">tiglCombinerPageRank::combineMessages</a></div><div class="ttdeci">uint_fast32_t combineMessages(DblMessage &amp;newMessage, MESSAGE_ITERATOR itOut)</div><div class="ttdoc">customized combine function that calls the generic sum combine </div><div class="ttdef"><b>Definition:</b> tiglExamplesPageRank.hpp:168</div></div>
<div class="ttc" id="tiglVertex_8hpp_html"><div class="ttname"><a href="tiglVertex_8hpp.html">tiglAPIVertex.hpp</a></div><div class="ttdoc">core vertex class definitions for TIGL </div></div>
<div class="ttc" id="classVertexPageRank_html_ad059296361152b10c464f3dd94f852d8"><div class="ttname"><a href="classVertexPageRank.html#ad059296361152b10c464f3dd94f852d8">PageRankVertex::PageRankVertex</a></div><div class="ttdeci">PageRankVertex(uint_fast32_t key)</div><div class="ttdoc">constructor: enable vertex processing even in the absence of messages </div><div class="ttdef"><b>Definition:</b> tiglExamplesPageRank.hpp:57</div></div>
<div class="ttc" id="classVertexPageRank_html_ab0311d771c6c45604d015ee3dbc3f78a"><div class="ttname"><a href="classVertexPageRank.html#ab0311d771c6c45604d015ee3dbc3f78a">PageRankVertex::init</a></div><div class="ttdeci">uint_fast32_t init(uint_fast32_t *pNumVertices, vector&lt; DblMessage, ALLOCATOR_TYPE &gt; *pOut)</div><div class="ttdoc">customized init function </div><div class="ttdef"><b>Definition:</b> tiglExamplesPageRank.hpp:116</div></div>
<div class="ttc" id="classVertex_html"><div class="ttname"><a href="classVertex.html">Vertex</a></div><div class="ttdoc">core vertex class for Pregel Engine (with only output edge buffer). It inherits the core vertex class...</div><div class="ttdef"><b>Definition:</b> tiglAPIVertex.hpp:39</div></div>
</div><!-- fragment --></div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated on Tue Jan 20 2015 16:21:51 for TI  Graph Library   (TIGL) by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.7
</small></address>
</body>
</html>
